//+------------------------------------------------------------------+ 
//|   TRO_BarPatterns                                                | 
//|                                                                  | 
//|   Copyright  2009, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/fx/ as your forex broker  |  
//| ...tell them therumpledone sent you!                             |  
//+------------------------------------------------------------------+ 


#property  copyright "Copyright  2009, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

#property indicator_chart_window

extern bool   TurnOff  = false ; 

extern int myChartX   = 10 ;
extern int myChartY   = 100 ;  
  
extern int myCorner   = 1 ;
extern string myFont  = "Courier New" ;
extern int myFontSize = 12 ;

 


extern bool   Show.Gauge  = true ; 
 
 
 

extern int myPeriod = 0 ;
 

extern color colorHOD    = Red ;
extern color colorLOD    = Blue ;
extern color colorClose  = Gold ;

extern color UpColor   = Lime;
extern color DownColor = Red;
extern color TextColor = DimGray;

//+------------------------------------------------------------------+



int h  ;
string lbl[15], lbl2[15];
int n, j, k ;

color pColor = Blue, VolColor = Magenta ;

string symbol, tChartPeriod, ShortName, TAG ;  
int    digits, period, win ; 
double point,  open, high, low, close, mid, range, pClose, pOpen, pHigh, pLow, pMid, pRange, cRange, PipDiff  ;  
double O, H, L, C ;
double O1, H1, L1, C1 ; 
double O2, H2, L2, C2 ;
double O3, H3, L3, C3 ;

int FillAmt = 11 , x001, x002, x003, x004, x005, x006, x007 ;   

int plotbars = 0 ;

bool TestVol ;
//+------------------------------------------------------------------+

int init()
  {
   if(myPeriod == 0) { period = Period() ; } else { period = myPeriod ; }    
   tChartPeriod =  TimeFrameToString(period) ;
   symbol       =  Symbol() ;
   digits       =  Digits ;
   point        =  Point ;
   TAG          = "BP" ; 
   ShortName    = TAG+symbol+period ;
   win          = 0 ;

   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }   
 
   
if( myCorner == 0 || myCorner == 2 )
{ 
   x001 = 10 ;
   x002 = 10 ;
   x003 = 90 ; 
   x004 = 150;
   x005 = 100 ;
   x006 = 90 ;  
   x007 = 90 ;
   FillAmt = 20 ;     
}
else
{
   x001 = 10 ;
   x002 = 10 ; //  
   x003 = 50 ;  //  
   x004 = 0 ; //  
   x005 = 10 ;
   x006 = 10 ;  
   x007 = 10 ;   
   FillAmt = 20 ; 
}
        
  
  deinit();   
   
   return(0);
  }
  
  
//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }
    
//+------------------------------------------------------------------+
int deinit()
  {
    
   ObDeleteObjectsByPrefix(TAG);          
   TRO() ;
   
   return(0);
  }
  
//+------------------------------------------------------------------+
int start()
{

if( TurnOff ) { return(0) ; }

n       = 10;
j       = 0 ;

if(Show.Gauge) 
{
   lbl[j]  = ShortName+j;
   lbl2[j] = fFill(tChartPeriod + " Bar Patterns", 20) ;
   DoShowHead(j, SteelBlue);
}

O  = iOpen( symbol, period, 0) ;
H  = iHigh( symbol, period, 0 ) ;
L  = iLow( symbol, period, 0) ;
C  = iClose( symbol, period, 0) ;

O1  = iOpen( symbol, period, 1) ;
H1  = iHigh( symbol, period, 1) ;
L1  = iLow( symbol, period, 1) ;
C1  = iClose( symbol, period, 1) ; 

O2  = iOpen( symbol, period, 2) ;
H2  = iHigh( symbol, period, 2 ) ;
L2  = iLow( symbol, period, 2) ;
C2  = iClose( symbol, period, 2) ;

O3  = iOpen( symbol, period, 3) ;
H3  = iHigh( symbol, period, 3 ) ;
L3  = iLow( symbol, period, 3) ;
C3  = iClose( symbol, period, 3) ;

if(Show.Gauge)  
{


if( H < H1 && H1 < H2 && L > L1 && L1 > L2)
{
j       = j + 1 ;
lbl[j]  = ShortName+j;
lbl2[j] = "Double Inside Bar " ;
DoShow( j, TextColor, C ) ;
}

 
if( H < H1 && L > L1 && L1 > MathMin(L2,L3) && H1 < MathMax(H2,H3) )
{
j       = j + 1 ;
lbl[j]  = ShortName+j;
lbl2[j] = "Arrow " ;
DoShow( j, TextColor, C ) ;
}


if( H > H1 && H1 < H2 && L < L1 && L1 > L2 )
{
j       = j + 1 ;
lbl[j]  = ShortName+j;
lbl2[j] = "Popgun  " ;
DoShow( j, TextColor, C ) ;
}


if( H < H3 && H1 < H3 && H2 < H3 && L > L3 && L1 > L3 && L2 > L3 )
{
j       = j + 1 ;
lbl[j]  = ShortName+j;
lbl2[j] = "3-in-1 " ;
DoShow( j, TextColor, C ) ;
}


if( H1 < H && H2 < H && H3 < H && L1 > L && L2 > L && L3 > L )
{
j       = j + 1 ;
lbl[j]  = ShortName+j;
lbl2[j] = "Reverse 3-in-1 " ;
DoShow( j, TextColor, C ) ;
}


} // if
 

 
 

   return(0);
  }
//+------------------------------------------------------------------+
  
void DoShowHead( int u, color dsColor )
{
string rlabelH = lbl[u] + "Head" ;
ObjectCreate(rlabelH,23,0,Time[0],PRICE_CLOSE);
ObjectSet(rlabelH, OBJPROP_CORNER, myCorner );
ObjectSet(rlabelH,OBJPROP_XDISTANCE, x001+myChartX);
ObjectSet(rlabelH,OBJPROP_YDISTANCE,n+myChartY);
ObjectSetText(rlabelH,lbl2[u],myFontSize,myFont,dsColor);

n = n+20;

return(0);
}
//+------------------------------------------------------------------+
  
void DoShow( int u, color dsColor, double dsPrice )
{
string sString = fFill(lbl2[u], 20)    ;
ObjectCreate(lbl[u],23,0,Time,PRICE_CLOSE);
ObjectSet(lbl[u], OBJPROP_CORNER, myCorner );
ObjectSet(lbl[u],OBJPROP_XDISTANCE,x002+myChartX);
ObjectSet(lbl[u],OBJPROP_YDISTANCE,n+myChartY);
ObjectSetText(lbl[u],sString,myFontSize,myFont,dsColor);


n = n+20;

   return(0);
  }



//+------------------------------------------------------------------+
string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}

//+------------------------------------------------------------------+

string fFill(string filled, int f ) 
{
   string FILLED ;
   
   FILLED = StringSubstr(filled + "                                         ",0,f) ;
   
return(FILLED);
}



      

//+------------------------------------------------------------------+  
 
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}


//+------------------------------------------------------------------+

/*

//+------------------------------------------------------------------+
string rtadjust( string rString )
{
 
 int sl = StringLen(rString) ;
 
 while(true)
 {
 
   if( sl == 5) { break ; } 
   if( sl == 4) { rString = " " + rString ; break ; }    
   if( sl == 3) { rString = "  " + rString ; break ; } 
   if( sl == 2) { rString = "   " + rString ; break ; } 
   if( sl == 1) { rString = "    " + rString ; break ; } 
    
   break ;
 }

return(rString) ;
} 
string Obj001 = lbl[u] + "price" ;
string sVal = fFill(DoubleToStr(dsPrice,digits), 7)    ;
ObjectCreate(Obj001,23,0,Time[0],PRICE_CLOSE);
ObjectSet(Obj001, OBJPROP_CORNER, myCorner );
ObjectSet(Obj001,OBJPROP_XDISTANCE, x003+myChartX);
ObjectSet(Obj001,OBJPROP_YDISTANCE,n+myChartY);
ObjectSetText(Obj001,sVal,myFontSize,myFont,dsColor);


string Obj002 = lbl[u] + "avg" ;
string sDif =  rtadjust( DoubleToStr(PipDiff,0) ) ;
ObjectCreate(Obj002,23,0,Time[0],PRICE_CLOSE);
ObjectSet(Obj002, OBJPROP_CORNER, myCorner );
ObjectSet(Obj002,OBJPROP_XDISTANCE, x004+myChartX);
ObjectSet(Obj002,OBJPROP_YDISTANCE,n+myChartY);
ObjectSetText(Obj002,sDif,myFontSize,myFont,pColor);
  
//+------------------------------------------------------------------+
void drawLabel(string name,double lvl,color Color)
{
    if(ObjectFind(name) != 0)
    {
        ObjectCreate(name, OBJ_TEXT, 0, Time[10], lvl);
        ObjectSetText(name, name, 14, "Arial", EMPTY);
        ObjectSet(name, OBJPROP_COLOR, Color);
    }
    else
    {
        ObjectMove(name, 0, Time[10], lvl);
    }
}


Comment(
 
"MathAbs((close - high) / point " , DoubleToStr(MathAbs((close - high) / point),Digits)  , "\n" , 
"MathAbs((close - low) / point " , DoubleToStr(MathAbs((close - low) / point),Digits)  , "\n" ,  

"myThreshold " , DoubleToStr(myThreshold,Digits) , "\n" ,
"TestVol " , TestVol , "\n" , 
"") ;  
 
*/